﻿Public Class Form1

    Function BinaryToDecimal(strBinary As String) As Integer
        Dim X As Integer, N As Integer
        Dim strTemp As String

        BinaryToDecimal = 0

        For X = 1 To Len(strBinary)
            strTemp = Mid(strBinary, X, 1)
            If strTemp = "1" Then
                N = N + 2 ^ (X - 1)
            End If
        Next

        BinaryToDecimal = N

    End Function

    Function DecodeIRIGBFrame(strFrame As String, ReturnString As Boolean) As String
        'If ParameterDirection ReturnString=False, the display on the output form, otherwise return the line of CSV data

        Dim strOutput As String, N As Integer, strTemp As String
        Dim strSection1 As String, strSection2 As String
        Dim strSection3 As String, strSection4 As String
        Dim strSection5 As String, strSection6 As String
        Dim strSection7 As String, strSection8 As String
        Dim strSection9 As String, strSection10 As String
        Dim strSec As String, strMin As String, strHour As String
        Dim strDay As String, strYear As String
        Dim strLSP As String, strLS As String
        Dim strDSP As String, strDST As String
        Dim strTZS As String, strTZOffset As String
        Dim strTZ30M As String, strTFOM As String
        Dim strPar As String, strCTQ As String
        Dim strSBS As String, strCSV As String, strCSVHeader As String

        strSection1 = Mid(strFrame, 1, 8)
        strSection2 = Mid(strFrame, 10, 9)
        strSection3 = Mid(strFrame, 20, 9)
        strSection4 = Mid(strFrame, 30, 9)
        strSection5 = Mid(strFrame, 40, 9)
        strSection6 = Mid(strFrame, 50, 9)
        strSection7 = Mid(strFrame, 60, 9)
        strSection8 = Mid(strFrame, 70, 9)
        strSection9 = Mid(strFrame, 80, 9)
        strSection10 = Mid(strFrame, 90, 9)

        N = BinaryToDecimal(Mid(strSection1, 6, 3)) * 10
        N = N + BinaryToDecimal(Mid(strSection1, 1, 4))
        If N > 9 Then
            strSec = Trim(Str(N))
        Else
            strSec = "0" + Trim(Str(N))
        End If


        N = BinaryToDecimal(Mid(strSection2, 6, 3)) * 10
        N = N + BinaryToDecimal(Mid(strSection2, 1, 4))
        If N > 9 Then
            strMin = Trim(Str(N))
        Else
            strMin = "0" + Trim(Str(N))
        End If

        N = BinaryToDecimal(Mid(strSection3, 6, 3)) * 10
        N = N + BinaryToDecimal(Mid(strSection3, 1, 4))
        If N > 9 Then
            strHour = Trim(Str(N))
        Else
            strHour = "0" + Trim(Str(N))
        End If


        strOutput = "Time - " + strHour + ":" + strMin + ":" + strSec

        'Day
        N = BinaryToDecimal(Mid(strSection4, 1, 4))
        N = N + BinaryToDecimal(Mid(strSection4, 6, 4)) * 10
        N = N + BinaryToDecimal(Mid(strSection5, 1, 2)) * 100
        If N > 9 Then
            strDay = Trim(Str(N))
        Else
            strDay = "0" + Trim(Str(N))
        End If

        'Year
        N = BinaryToDecimal(Mid(strSection6, 1, 4))
        N = N + BinaryToDecimal(Mid(strSection6, 6, 4)) * 10
        If N > 9 Then
            strYear = Trim(Str(N))
        Else
            strYear = "0" + Trim(Str(N))
        End If



        strOutput = strOutput + vbCrLf + "Day - " + strDay
        strOutput = strOutput + vbCrLf + "Year - " + strYear

        strLSP = Mid(strSection7, 1, 1)
        strLS = Mid(strSection7, 2, 1)
        strDSP = Mid(strSection7, 3, 1)
        strDST = Mid(strSection7, 4, 1)
        strTZS = Mid(strSection7, 5, 1)

        'Time Zone offset
        N = BinaryToDecimal(Mid(strSection7, 6, 4))
        If N > 9 Then
            strTZOffset = Trim(Str(N))
        Else
            strTZOffset = "0" + Trim(Str(N))
        End If

        strTZ30M = Mid(strSection8, 1, 1)

        'Time figure of merit
        N = BinaryToDecimal(Mid(strSection8, 2, 4))
        If N > 9 Then
            strTFOM = Trim(Str(N))
        Else
            strTFOM = "0" + Trim(Str(N))
        End If

        strPar = Mid(strSection8, 6, 1)

        'C37.118 Continuous Time Quality
        N = BinaryToDecimal(Mid(strSection8, 7, 3))
        If N > 9 Then
            strCTQ = Trim(Str(N))
        Else
            strCTQ = "0" + Trim(Str(N))
        End If

        strTemp = Mid(strSection9, 1, 9)
        strTemp = strTemp + Mid(strSection10, 1, 8)

        strSBS = BinaryToDecimal(strTemp)


        strOutput = strOutput + vbCrLf + "LSP - " + strLSP
        strOutput = strOutput + vbCrLf + "LS - " + strLS
        strOutput = strOutput + vbCrLf + "DSP - " + strDSP
        strOutput = strOutput + vbCrLf + "DST - " + strDST
        strOutput = strOutput + vbCrLf + "TZS - " + strTZS
        strOutput = strOutput + vbCrLf + "TZ Offset - " + strTZOffset
        strOutput = strOutput + vbCrLf + "TZ 30M - " + strTZ30M
        strOutput = strOutput + vbCrLf + "TFOM - " + strTFOM
        strOutput = strOutput + vbCrLf + "Parity - " + strPar
        strOutput = strOutput + vbCrLf + "CTQ - " + strCTQ
        strOutput = strOutput + vbCrLf + "SBS - " + strSBS

        strCSVHeader = "Year,Day,Time,LSP,LS,DSP,DST,TZS,TZ Offset,TZ30M,TFOM,Parity,CTQ,SBS"
        strCSV = strYear + "," + strDay + "," + strHour + ":" + strMin + ":" + strSec + "," + strLSP + "," + strLS
        strCSV += "," + strDSP + "," + strDST + "," + strTZS + "," + strTZOffset + "," + strTZ30M
        strCSV += "," + strTFOM + "," + strPar + "," + strCTQ + "," + strSBS


        If ReturnString = True Then
            DecodeIRIGBFrame = strCSV
        Else
            DecodeIRIGBFrame = strOutput
            frmDisplay.Show()
            frmDisplay.lblTime.Text = strHour + ":" + strMin + ":" + strSec
            frmDisplay.lblYear.Text = strYear
            frmDisplay.lblDay.Text = strDay
            frmDisplay.lblLSP.Text = strLSP
            frmDisplay.lblLS.Text = strLS
            frmDisplay.lblDSP.Text = strDSP
            frmDisplay.lblDST.Text = strDST
            frmDisplay.lblTZS.Text = strTZS
            frmDisplay.lblTZOffset.Text = strTZOffset
            frmDisplay.lblTZ30M.Text = strTZ30M
            frmDisplay.lblTFOM.Text = strTFOM
            frmDisplay.lblParity.Text = strPar
            frmDisplay.lblTQ.Text = strCTQ
            frmDisplay.lblSBS.Text = strSBS
        End If

    End Function

    Private Sub ListBox1_Click(sender As Object, e As EventArgs) Handles ListBox1.Click
        Dim strFrame As String, strTemp

        strFrame = ListBox1.SelectedItem.ToString
        strTemp = DecodeIRIGBFrame(strFrame, False)
    End Sub

    Private Sub ListBox1_DoubleClick(sender As Object, e As System.EventArgs) Handles ListBox1.DoubleClick
        Dim strFrame As String, strTemp

        strFrame = ListBox1.SelectedItem.ToString
        strTemp = DecodeIRIGBFrame(strFrame, False)

    End Sub

    Private Sub OpenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenToolStripMenuItem.Click
        Dim strInputFileName As String, strTemp As String
        Dim X As Integer, strFrame As String
        Dim N As Integer

        OpenFileDialog1.ShowDialog()
        strInputFileName = OpenFileDialog1.FileName

        ListBox1.Items.Clear()

        FileOpen(1, strInputFileName, OpenMode.Input)

        Me.Text = "IRIG Decoder - " & strInputFileName

        Do While Not EOF(1)
            strTemp = LineInput(1)
            If strTemp = "M" Then
                strFrame = ""
                For X = 1 To 10
                    If Not EOF(1) Then strTemp = LineInput(1)
                    strFrame = strFrame + strTemp
                Next
                ListBox1.Items.Add(strFrame)
                N = N + 1
                Application.DoEvents()
            End If
            If N / 100 = Int(N / 100) Then
                ToolStripStatusLabel1.Text = "Reading: " + Str(N)
            End If
        Loop
        FileClose(1)
        MsgBox("File load complete", MsgBoxStyle.Information, "IRIG Decoder")
        ToolStripStatusLabel1.Text = "Reading: " + Str(N)
    End Sub

    Private Sub WriteCSVFileToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles WriteCSVFileToolStripMenuItem.Click
        Dim X As Integer, strData As String
        Dim strOutFile As String

        'strFile = "C:\Temp\Test out.txt"

        SaveFileDialog1.OverwritePrompt = True
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName = "" Then Exit Sub
        strOutFile = SaveFileDialog1.FileName
        If IO.File.Exists(strOutFile) Then
            IO.File.Delete(strOutFile)
        End If

        IO.File.AppendAllText(strOutFile, "Year,Day,Time,LSP,LS,DSP,DST,TZS,TZ Offset,TZ30M,TFOM,Parity,CTQ,SBS" + vbCrLf)
        For X = 0 To ListBox1.Items.Count - 1
            strData = DecodeIRIGBFrame(ListBox1.Items.Item(X), True)
            IO.File.AppendAllText(strOutFile, strData + vbCrLf)
            'Application.DoEvents()

            'Update the status every 100 items
            If X / 100 = Int(X / 100) Then
                ToolStripStatusLabel1.Text = "Writing: " + Str(X)
                Application.DoEvents()
            End If
        Next

        MsgBox("CSV File write complete!", MsgBoxStyle.Information, "IRIG Decoder")
        ToolStripStatusLabel1.Text = "Writing: " + Str(X)
    End Sub

    Private Sub ConvertToCSVToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles ConvertToCSVToolStripMenuItem.Click
        Dim strInputFileName As String, strTemp As String
        Dim strFrame As String
        Dim N As Integer

        Dim X As Integer, strData As String
        Dim strOutFile As String

        OpenFileDialog1.ShowDialog()
        strInputFileName = OpenFileDialog1.FileName

        FileOpen(1, strInputFileName, OpenMode.Input)

        SaveFileDialog1.OverwritePrompt = True
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName = "" Then Exit Sub
        strOutFile = SaveFileDialog1.FileName
        If IO.File.Exists(strOutFile) Then
            IO.File.Delete(strOutFile)
        End If

        IO.File.AppendAllText(strOutFile, "Year,Day,Time,LSP,LS,DSP,DST,TZS,TZ Offset,TZ30M,TFOM,Parity,CTQ,SBS" + vbCrLf)

        Do While Not EOF(1)
            strTemp = LineInput(1)
            If strTemp = "M" Then
                strFrame = ""
                For X = 1 To 10
                    If Not EOF(1) Then strTemp = LineInput(1)
                    strFrame = strFrame + strTemp
                Next
                strData = DecodeIRIGBFrame(strFrame, True)
                IO.File.AppendAllText(strOutFile, strData + vbCrLf)
                'Application.DoEvents()
                N = N + 1
            End If
            If N / 100 = Int(N / 100) Then
                ToolStripStatusLabel1.Text = "Converting to CSV: " + Str(N)
                Application.DoEvents()
            End If
        Loop
        FileClose(1)
        MsgBox("File conversion complete", MsgBoxStyle.Information, "IRIG Decoder")
        ToolStripStatusLabel1.Text = "Converted: " + Str(N)

    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        Dim strFrame As String, strTemp

        strFrame = ListBox1.SelectedItem.ToString
        strTemp = DecodeIRIGBFrame(strFrame, False)
    End Sub
End Class